<template>
  <div id="teacher_class_grading_wrapper" class="bt-container">
    <el-breadcrumb style="font-size: 24px; margin-top: 40px; margin-bottom: 40px;" separator="|">
      <el-breadcrumb-item :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentTeachingClass(classId) ? currentTeachingClass(classId).name : '' }}</el-breadcrumb-item>
      <el-breadcrumb-item>{{ $t('CLASS_MENU.GRADING_MANAGE') }}</el-breadcrumb-item>
       <div style="text-align: right;">
        <a href="javascript:history.back();">
          <el-button size="small">{{ $t('BOARD.BACK') }}</el-button>
        </a>
      </div> 
    </el-breadcrumb>
    <!--과목명 누르면 바로 강의 목록으로 돌아가도록 수정 190702
      네이밍 '결과보기' -> '채점관리'로 변경
      <h2>{{ currentTeachingClass(classId) ? currentTeachingClass(classId).name : '' }} > 결과보기</h2>
    -->
    <el-tabs v-model="activeTab">
      <el-tab-pane :label="$t('RESULT.QUES_RESULT')" name="question">
        <div class="one-lecture-wrapper" v-for="lecture in questionList" :key="lecture.lectureId">
          <h3>{{ lecture.name }}</h3>
          <el-table :data="lecture.questions">
            <el-table-column
              prop="no"
              label="No.">
            </el-table-column>
            <el-table-column
              prop="type"
              :label="$t('LECTURE_LIST.TYPE')">
              <template slot-scope="scope">
                <span v-if="scope.row.type === '객관'">
                  {{ $t('QUESTION.MULTI_ANS') }}
                </span>
                <span v-else-if="scope.row.type === '단답'">
                  {{ $t('QUESTION.SHORT_ANS') }}
                </span>
                <span v-else-if="scope.row.type === '서술'">
                  {{ $t('QUESTION.ESSAY') }}
                </span>
                <span v-else-if="scope.row.type === '멀티미디어'">
                  {{ $t('QUESTION.MULTIMEDIA') }}
                </span>
                <span v-else-if="scope.row.type === '연결형'">
                  {{ $t('QUESTION.CONNECTION') }}
                </span>
              </template>
            </el-table-column>
            <el-table-column
              prop="name"
              :label="$t('RESULT.LEC_ITEM_NAME')">
            </el-table-column>
            <el-table-column
              :label="$t('RESULT.STD_GRADED_NUM')">
              <template slot-scope="scope">
                {{ scope.row.numberOfScored }} / {{scope.row.numberOfStudent}}
              </template>
            </el-table-column>
            <el-table-column
              :label="$t('RESULT.AVRG_SCORE')">
              <template slot-scope="scope">
                {{ scope.row.avgScore.toFixed(2) }} / {{scope.row.score}}
              </template>
            </el-table-column>
            <el-table-column
              label="">
              <template slot-scope="scope">
                <el-button size="small" @click="onClickResult('QUESTION', scope.row.itemId)">{{ $t('RESULT.VIEW_DETAIL') }}</el-button>
              </template>
            </el-table-column>
          </el-table>
        </div>
      </el-tab-pane>

      <el-tab-pane :label="$t('RESULT.SURV_RESULT')" name="survey">
        <div class="one-lecture-wrapper" v-for="lecture in surveyList" :key="lecture.lectureId">
          <h3>{{ lecture.name }}</h3>
          <el-table :data="lecture.surveys">
            <el-table-column
              prop="no"
              label="No.">
            </el-table-column>
            <el-table-column
              prop="type"
              :label="$t('LECTURE_LIST.TYPE')">
              <template slot-scope="scope">
                <span v-if="scope.row.type === '객관'">
                  {{ $t('SURVEY.MULTI_CHOI') }}
                </span>
                <span v-else-if="scope.row.type === '서술'">
                  {{ $t('SURVEY.ESSAY') }}
                </span>
              </template>
            </el-table-column>
            <el-table-column
              prop="name"
              :label="$t('RESULT.LEC_ITEM_NAME')">
            </el-table-column>
            <el-table-column
              prop="numberOfStudent"
              :label="$t('RESULT.SRVY_PRTCP_NUM')">
            </el-table-column>
            <el-table-column
              label="">
              <template slot-scope="scope">
                <el-button size="small" @click="onClickResult('SURVEY', scope.row.itemId)">{{ $t('STUDENT_MENU.VIEW_RESULTS') }}</el-button>
              </template>
            </el-table-column>
          </el-table>
        </div>
      </el-tab-pane>

      <el-tab-pane :label="$t('RESULT.PRACT_RESULT')" name="practice">
        <div class="one-lecture-wrapper" v-for="lecture in practiceList" :key="lecture.name">
          <h3>{{ lecture.name }}</h3>
          <el-table :data="lecture.practices">
            <el-table-column
              prop="no"
              label="No.">
            </el-table-column>
            <el-table-column
              prop="name"
              :label="$t('RESULT.LEC_ITEM_NAME')">
            </el-table-column>
            <el-table-column
              :label="$t('RESULT.PRCT_PRTCP_NUM')">
              <template slot-scope="scope">
                {{ scope.row.totalNum }} / {{ scope.row.totalNum }}
              </template>
            </el-table-column>
            <el-table-column
              :label="$t('RESULT.AVRG_CODE_SCORE')">
              <template slot-scope="scope">
                {{ scope.row.codeScore }} / {{ scope.row.maxCode }}
              </template>
            </el-table-column>
            <el-table-column
              :label="$t('RESULT.AVRG_RES_SCORE')">
              <template slot-scope="scope">
                {{ scope.row.outputScore }} / {{ scope.row.maxOutput }}
              </template>
            </el-table-column>
            <!--el-table-column
              label="">
              <template slot-scope="scope">
                <el-button size="small" @click="onClickResult('PRACTICE', scope.row.itemId)">상세보기</el-button>
              </template>
            </el-table-column-->
          </el-table>
        </div>
      </el-tab-pane>

      <el-tab-pane :label="$t('RESULT.CODING_RESULT')" name="coding_assignment">
        <div class="one-lecture-wrapper" v-for="lecture in codingList" :key="lecture.name">
          <h3>{{ lecture.name }}</h3>
          <el-table :data="lecture.codings">
            <el-table-column
              prop="no"
              label="No.">
            </el-table-column>
            <el-table-column
              prop="name"
              :label="$t('RESULT.LEC_ITEM_NAME')">
            </el-table-column>
            <el-table-column
              :label="$t('RESULT.CD_ASSGN_PRTCP_NUM')">
              <template slot-scope="scope">
                {{ scope.row.totalNum }} / {{ scope.row.totalNum }}
              </template>
            </el-table-column>
            <el-table-column
              :label="$t('RESULT.AVRG_SCORE')">
              <template slot-scope="scope">
                {{ scope.row.score }} / {{ scope.row.maxScore }}
              </template>
            </el-table-column>
            <!--el-table-column
              label="">
              <template slot-scope="scope">
                <el-button size="small" @click="onClickResult('CODING', scope.row.itemId)">상세보기</el-button>
              </template>
            </el-table-column-->
          </el-table>
        </div>
      </el-tab-pane>
    </el-tabs>
  </div>
</template>

<style lang="scss" scoped>
  #teacher_class_grading_wrapper {
    .one-lecture-wrapper {
      margin-bottom: 40px;
    }
    .align-right {
      text-align: right;
    }
  }
</style>


<script>
import { mapActions, mapState, mapGetters } from 'vuex';
// import lectureItemService from '../../services/lectureItemService';

export default {
  name: 'TeacherClassGrading',
  data() {
    return {
      activeTab: 'question',
      codingList: '',
    };
  },
  computed: {
    ...mapState('grading', [
      'theResult',
      'surveyList',
      'questionList',
      'practiceList',
    ]),
    ...mapGetters('NNclass', [
      'currentTeachingClass',
    ]),
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.classId, 10);
    },
  },
  async created() {
    const vm = this;
    vm.getClassTotalResult({
      classId: vm.classId,
    });
    /*
    const practiceResults = await lectureItemService.getWholeSimilarityScores({
      classId: vm.classId,
    }); */
    // 실습 결과 만들기
    vm.practiceList = [];
    vm.questionList.forEach((x) => {
      const temp = {};
      temp.lectureId = x.lectureId;
      temp.name = x.name;
      // const practices = practiceResults.data[x.lectureId];
      temp.practices = [];
      /* 실습 아이템이 있다면
      if (practices.length !== 0) {
        const itemSet = [];
        const itemIdSet = [];
        practices.forEach((y) => {
          // 새로운 아이템의 답안 결과
          if (itemIdSet.includes(y.lecture_item_id) === false) {
            itemIdSet.push(y.lecture_item_id);
            const tmpp = [];
            tmpp.push(y);
            itemSet.push(tmpp);
          } else {
            // 기존에 존재하던 아이템의 답안 결과
            const setWhere = itemIdSet.indexOf(y.lecture_item_id);
            itemSet[setWhere].push(y);
          }
        });
        // 분류된 답안들 아이템에 따라 다시 계산
        itemSet.forEach((z, index) => {
          const tmp2 = {};
          tmp2.name = z[0].item_name;
          tmp2.no = index + 1;
          tmp2.itemId = z[0].lecture_item_id;
          let totalNum = 0;
          let totalCodeScore = 0;
          let totalOutputScore = 0;
          z.forEach((w) => {
            if (w.code_score !== -1) {
              // 제출한 경우
              totalNum += 1;
              totalCodeScore += w.code_score;
              totalOutputScore += w.output_score;
            }
          });
          if (totalNum !== 0) {
            // 제출한 사람이 있으면
            tmp2.totalNum = totalNum;
            tmp2.maxCode = 100;
            tmp2.codeScore = ((totalCodeScore / totalNum) * 100).toFixed(2);
            tmp2.maxOutput = 100;
            tmp2.outputScore = ((totalOutputScore / totalNum) * 100).toFixed(2);
          } else {
            // 제출한 사람이 없으면
            tmp2.totalNum = 0;
            tmp2.maxCode = 100;
            tmp2.codeScore = 0;
            tmp2.maxOutput = 100;
            tmp2.outputScore = 0;
          }
          temp.practices.push(tmp2);
        });
      }
      vm.practiceList.push(temp); */
    });
    /* 코딩 과제 결과 만들기
    const codingResults = await lectureItemService.getWholeCodingScores({
      classId: vm.classId,
    });
    vm.codingList = [];
    vm.questionList.forEach((x) => {
      const temp = {};
      temp.lectureId = x.lectureId;
      temp.name = x.name;
      const codings = codingResults.data[x.lectureId];
      temp.codings = [];
      // 코딩 과제 아이템이 있다면
      if (codings.length !== 0) {
        const itemSet = [];
        const itemIdSet = [];
        codings.forEach((y) => {
          // 새로운 아이템의 답안 결과
          if (itemIdSet.includes(y.lecture_item_id) === false) {
            itemIdSet.push(y.lecture_item_id);
            const tmpp = [];
            tmpp.push(y);
            itemSet.push(tmpp);
          } else {
            // 기존에 존재하던 아이템의 답안 결과
            const setWhere = itemIdSet.indexOf(y.lecture_item_id);
            itemSet[setWhere].push(y);
          }
        });
        // 분류된 답안들 아이템에 따라 다시 계산
        itemSet.forEach((z, index) => {
          const tmp2 = {};
          tmp2.name = z[0].item_name;
          tmp2.no = index + 1;
          tmp2.itemId = z[0].lecture_item_id;
          tmp2.maxScore = z[0].max_score;
          let totalNum = 0;
          let totalScore = 0;
          z.forEach((w) => {
            if (w.code_score !== -1) {
              // 제출한 경우
              totalNum += 1;
              totalScore += w.score;
            }
          });
          if (totalNum !== 0) {
            // 제출한 사람이 있으면
            tmp2.totalNum = totalNum;
            tmp2.score = (totalScore / totalNum).toFixed(2);
          } else {
            // 제출한 사람이 없으면
            tmp2.totalNum = 0;
            tmp2.score = 0;
          }
          temp.codings.push(tmp2);
        });
      }
      vm.codingList.push(temp);
    }); */
  },
  methods: {
    ...mapActions('grading', [
      'getClassTotalResult',
    ]),
    onClickResult(type, itemId) {
      const vm = this;
      if (type === 'QUESTION') {
        vm.$router.push(`/a/teacher/class/${vm.classId}/grading/question/${itemId}`);
      } else if (type === 'SURVEY') {
        vm.$router.push(`/a/teacher/class/${vm.classId}/grading/survey/${itemId}`);
      } else if (type === 'PRACTICE') {
        vm.$router.push(`/a/teacher/class/${vm.classId}/grading/practice/${itemId}`);
      } else if (type === 'CODING') {
        // need fixing
      }
    },
  },
};
</script>
